const assert = (message) => (bool) => {
	if (!bool) { throw new Error(message); }
};

const assertString = assert('Either.Reject expected string');

const Reject = function(value) {

	assertString(typeof value === 'string');

	const x = () => value;

	x.map = () => x;
	x.orElse = (fn) => {
		fn(value);
		return Reject(value);
	};

	return x;

};

const Resolve = function(value) {

	const x = () => value;

	x.map = (fn) => Resolve(fn(value));
	x.orElse = () => x;

	return x;

};

const Either = { Reject, Resolve };

module.exports = Either;